package com.titan.reservation;

import com.titan.cabin.*;
import com.titan.cruise.*;
import com.titan.customer.*;

import javax.ejb.*;
import java.rmi.*;
import javax.naming.*;
import java.util.Properties;


public class ReservationBean implements javax.ejb.EntityBean {
    
    public int customerID;
    public int cruiseID;
    public int cabinID;
    public double price;
    
   
    public transient javax.ejb.EntityContext ejbContext;

    public void ejbCreate(Customer customer, Cruise cruise, Cabin cabin, double price)
    throws RemoteException{
        this.customerID = ((CustomerPK)customer.getPrimaryKey()).id;
        this.cruiseID = ((CruisePK)cruise.getPrimaryKey()).id;
        this.cabinID = ((CabinPK)cabin.getPrimaryKey()).id;
        this.price = price;
    }

    public void ejbPostCreate(Customer customer, Cruise cruise, Cabin cabin, double price){
        // do nothing;
    }
    public double getPrice( ){
        return price;
    }
    public int getCabinID( )
    throws RemoteException, FinderException {
        return cabinID;
    }
    public int getCustomerID( )
    throws RemoteException, FinderException {
        return customerID;
    }
    public int getCruiseID( )
    throws RemoteException, FinderException{
        return cruiseID;
    }
	public void setEntityContext(javax.ejb.EntityContext ctx){
	     //not implemented
    }
    public void unsetEntityContext(){
	     //not implemented
    }
    public void ejbActivate(){
        // not implmented
    }
    public void ejbPassivate(){
        // not implmented
    }
    public void ejbLoad(){
        // not implmented
    }
    public void ejbStore(){
        // not implmented
    }
    public void ejbRemove(){
        // not implmented
    }
}